"""! @file filters.py
@brief Filter library for the application
@author xlanro00
"""

import numpy as np
import matplotlib.pyplot as plt
import cv2 as cv


class filter:
    def __init__(self, input_file, output_file, img):
        self.input_file = input_file
        self.output_file = output_file
        self.img = img


class filter_average(filter):
    def __init__(self, input_file, output_file, img):
        super().__init__(input_file, output_file, img)

    def apply(self):
        kernel = np.ones((5, 5), np.float32)/25
        dst = cv.filter2D(self.img, -1, kernel)
        plt.xticks([]), plt.yticks([])
        plt.imshow(dst)
        print("Average filter")


class filter_blur(filter):
    def __init__(self, input_file, output_file, img):
        super().__init__(input_file, output_file, img)

    def apply(self):
        blur = cv.blur(self.img, (5, 5))
        plt.xticks([]), plt.yticks([])
        plt.imshow(blur)
        print("Blurring filter")


class filter_gaussian(filter):
    def __init__(self, input_file, output_file, img):
        super().__init__(input_file, output_file, img)

    def apply(self):
        blur = cv.GaussianBlur(self.img, (5, 5), 0)
        plt.xticks([]), plt.yticks([])
        print("Gaussian filter")
